//------------------------------------------------------------------
#property copyright "thefxpros"
#property link      "thefxpros@katamail.com"
//------------------------------------------------------------------


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 DarkGreen
#property indicator_color4 FireBrick
#property indicator_width1 1
#property indicator_width2 2


//
//
//

extern int      TimeFrame     = 0;
extern int      Length        = 2;
extern double   Coeff         = 1.75;

extern color    UpBodyColor   = LimeGreen;
extern color    DnBodyColor   = Orange;
extern color    UpWickColor   = DarkGreen;
extern color    DnWickColor   = FireBrick;
extern int      WickWidth     = 1;
extern int      BodyWidth     = 2;

//


double UpBodyBuffer[];
double DnBodyBuffer[];
double UpWickBuffer[];
double DnWickBuffer[];
double UpLineBuffer[];
double DnLineBuffer[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int init()
{


   IndicatorBuffers(6);
   SetIndexBuffer(0,UpBodyBuffer);   SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, BodyWidth, UpBodyColor);
   SetIndexBuffer(1,DnBodyBuffer);   SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, BodyWidth, DnBodyColor);
   SetIndexBuffer(2,UpWickBuffer);   SetIndexStyle(2,DRAW_HISTOGRAM, EMPTY, WickWidth, UpWickColor);
   SetIndexBuffer(3,DnWickBuffer);   SetIndexStyle(3,DRAW_HISTOGRAM, EMPTY, WickWidth, DnWickColor); 
   SetIndexBuffer(4,UpLineBuffer);
   SetIndexBuffer(5,DnLineBuffer);
   
   
   IndicatorShortName("Wilders trailing stop MTF ("+Length+","+Coeff+")");
      Length = MathMax(Length,1);
      

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("Wilders trailing stop MTF ("+TimeFrameStr+")");
   return(0);

  }

//----

   
 
//+------------------------------------------------------------------+
//| MTF function                                                     |
//+------------------------------------------------------------------+


int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

// Plot defined time frame on to current time frame

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= MathMin(Bars-counted_bars+3*TimeFrame/Period(),Bars-1);
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;
   

/*********************************************************************************************************
   Add your main indicator loop below. You can reference an existing indicator with its iName or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 ********************************************************************************************************/ 
  
  
      UpLineBuffer[i]=iCustom(Symbol(),TimeFrame,"Wilders trailing stop",Length,Coeff,1,y);
      DnLineBuffer[i]=iCustom(Symbol(),TimeFrame,"Wilders trailing stop",Length,Coeff,0,y);
      
     if (UpLineBuffer[i]!=EMPTY_VALUE)
   {
      UpBodyBuffer[i]   = High[i];
      DnBodyBuffer[i]   = Low[i];
      UpWickBuffer[i]   = MathMax(Open[i],Close[i]);
      DnWickBuffer[i]   = MathMin(Open[i],Close[i]);
   }
   else
   {
      DnBodyBuffer[i]   = High[i];
      UpBodyBuffer[i]   = Low[i];
      DnWickBuffer[i]   = MathMax(Open[i],Close[i]);
      UpWickBuffer[i]   = MathMin(Open[i],Close[i]);
   }
        
   }   
   return(0);
  }
//+------------------------------------------------------------------+